#!/usr/bin/python
# -*- coding: utf-8 -*-

# PyDecoMailM - a modification of "PyDecoMail"
# SYMBIAN_UID = 0xeaf432b6
# masa
# (c) 2013-2014 masa
__script__  = "PyDecoMailM"
__version__ = "0.04(0)"
__copy__    = "masa"
__web__     = "http://masaland.cocolog-nifty.com/"


#original copyright
#---------------------------------#
#   att1ファイル表示スクリプト    #
#         PyDecoMail              #
#                                 #
#   for pys60 1.4.x or 1.9.x      #
#http://twitter.com/galleriapizza #
#---------------------------------#

import sys, os
#sys.setdefaultencoding('utf-8')
if os.path.isdir('E:\\Python\\lib') :
    sys.path.insert(0, 'E:\\Python\\lib')

# モジュール読込
import re
import time
from stat import *
import appuifw, e32, globalui

lock = e32.Ao_lock()
lock2 = e32.Ao_lock()
#--------------------------------------------------------------------------
import messaging

try:
    import japanese
    JP_CODECS = 1
except:
    JP_CODECS = 0
    appuifw.query(unicode("Japanese codecs をインストールして下さい", "utf-8"), "query")
#--------------------------------------------------------------------------

# -------- #
# 初期設定 #
# -------- #
CONF = {}
# 設定ファイルパス
CONF['setting_file_path'] = ""
if os.path.isdir("E:\\DATA") == True:
    if os.path.isdir("E:\\DATA\\Galleria") == False:
        os.mkdir("E:\\DATA\\Galleria")
        if os.path.isdir("E:\\DATA\\Galleria") == True:
            CONF['setting_file_path'] = "E:\\DATA\\Galleria\\PyDecoMailM.conf"
    else:
        CONF['setting_file_path'] = "E:\\DATA\\Galleria\\PyDecoMailM.conf"

# 設定の読込
if os.path.isfile(CONF['setting_file_path']) == True:
    fileobj = open(CONF['setting_file_path'], "r")
    setting_text = fileobj.read()
    fileobj.close()
    setting_list = setting_text.split(',')
    # 検索ドライブ
    if len(setting_list[0]) > 0:
        CONF['setting_drive_name'] = setting_list[0]
    else:
        CONF['setting_drive_name'] = ""
        CONF['setting_drive'] = 0
    # 日数制限
    if len(setting_list[1]) > 0:
        CONF['setting_days'] = int(setting_list[1])
    else:
        CONF['setting_days'] = 2
    # ファイル数制限
    if len(setting_list[2]) > 0:
        CONF['setting_limit'] = int(setting_list[2])
    else:
        CONF['setting_limit'] = 2
    # ATT1調整方法
    if len(setting_list[3]) > 0 and int(setting_list[3]) < 4:
        CONF['setting_att1'] = int(setting_list[3])
    else:
        CONF['setting_att1'] = 0
    # 検索方法
    if len(setting_list[4]) > 0:
        CONF['setting_ts'] = int(setting_list[4])
    else:
        CONF['setting_ts'] = 1
    # ソート
    if len(setting_list[5]) > 0:
        CONF['setting_sort'] = int(setting_list[5])
    else:
        CONF['setting_sort'] = 1
    # 電話番号（SMS送信先）
    if len(setting_list[6]) > 0:
        CONF['setting_send_to'] = setting_list[6]
    else:
        CONF['setting_send_to'] = "+81901122xxxx"
    # SMS最大長
    if len(setting_list[7]) > 0:
        CONF['setting_sms_limit'] = int(setting_list[7])
    else:
        CONF['setting_sms_limit'] = 192

else:
    # デフォルト設定
    CONF['setting_drive'] = 0
    CONF['setting_days'] = 2
    CONF['setting_limit'] = 2
    CONF['setting_att1'] = 0
    CONF['setting_ts'] = 1
    CONF['setting_sort'] = 1
    CONF['setting_drive_name'] = ""
    CONF['setting_send_to'] = "+81901122xxxx"
    CONF['setting_sms_limit'] = 192


# 検索ディレクトリの指定
CONF['mail_dir'] = ""
CONF['drives'] = []
drives = e32.drive_list()
drive_num = 0
for d in drives:
    if os.path.isdir(d + "\\Private\\1000484b\\Mail2\\00001001_S") == True:
        CONF['drives'].append(d)
        if CONF['setting_drive_name'] == d:
            CONF['mail_dir'] = d + "\\Private\\1000484b\\Mail2\\00001001_S"
            CONF['setting_drive'] = drive_num

        elif len(CONF['mail_dir']) == 0 and len(CONF['setting_drive_name']) == 0:
            CONF['mail_dir'] = d + "\\Private\\1000484b\\Mail2\\00001001_S"
        drive_num += 1

# マスタ情報（日数制限、ファイル制限）
DAYS_AGO_MASTER   = (0, 1, 3, 7, 14, 30)
FILE_LIMIT_MASTER = (0, 5, 10, 30, 50, 100)
CONF['app_path'] = os.getcwd() + "\\";

# hour_ago時間以内に作成されたatt1ファイルを収集
CONF['hour_ago'] = 24 * DAYS_AGO_MASTER[CONF['setting_days']]
# 取得ファイル数制限
CONF['file_limit'] = FILE_LIMIT_MASTER[CONF['setting_limit']]


# ファイル更新日時比較用タイムスタンプ（グローバル）
CONF['check_ts'] = 0
# 該当ファイルパス保持用（グローバル）
ATT1_FILE_LIST = {}
# 該当ファイル更新日時保持用（グローバル）
ATT1_FILE_UPDATE = {}
# 該当ファイル数保持用（グローバル）
FILE_COUNT = 0
# 検索対象ファイル総数
FILE_TOTAL = 0
# 一時ファイルのパス（グローバル）
TEMP_FILE_PATH = "E:\\att1"
#リストボックス関連（グローバル）
LISTBOX = ""
UPDATE_LIST = [] # 保持用リスト（ファイル更新日時）
PATH_LIST = [] # 保持用リスト（ファイルパス）
#エンコード指定（グローバル）
FIXED_ENCODE = "" #default "":Auto


# pys60のバージョンが1.9.x系かチェック
if re.match("^1\.9\.", e32.pys60_version) == None:
    CONF['ver19']     = False
else:
    CONF['ver19'] = True

# 現在の時刻取得（タイムスタンプ）
start_ts = time.time()


# ---------- #
# 設定の保存 #
# ---------- #

def saveConfig():
    global CONF

    save_data = ""
    save_data = str(CONF['drives'][CONF['setting_drive']]) # 検索ドライブ
    save_data = save_data + "," + str(CONF['setting_days']) # 日数制限
    save_data = save_data + "," + str(CONF['setting_limit']) # ファイル数制限
    save_data = save_data + "," + str(CONF['setting_att1']) # ATT1調整方法
    save_data = save_data + "," + str(CONF['setting_ts']) # 検索対象
    save_data = save_data + "," + str(CONF['setting_sort']) # ソート
    save_data = save_data + "," + CONF['setting_send_to'] # 電話番号（SMS送信先）
    save_data = save_data + "," + str(CONF['setting_sms_limit']) # SMS最大長

    # ディレクトリチェック
    if os.path.isdir("E:\\DATA\\Galleria") == False:
        CONF['setting_file_path'] = ""

    if len(CONF['setting_file_path']) == 0:
        return False

    fileobj = open(CONF['setting_file_path'], "w")
    fileobj.write(save_data)
    fileobj.close()

# -------------------- #
# att1ファイル検索関数 #
# -------------------- #

def searchAtt1File(search_dir):

    # グローバル変数
    global FILE_COUNT, ATT1_FILE_LIST, ATT1_FILE_UPDATE, FILE_TOTAL, CONF

    # ディレクトリ内を検索開始
    if os.path.isdir(search_dir) == True:
        # ファイル名一覧取得（ディレクトリ名も含む）
        files = os.listdir(search_dir)
        # 取得した一覧から１つずつ抜き出す
        for filename in files:
            # ファイルパス作成
            if CONF['ver19'] == False:
                path_temp = search_dir + "\\" + unicode(filename, "utf-8")
            else:
                path_temp = search_dir + "\\" + filename
            # 0-9a-fまでの１文字ディレクトリの場合だけ掘り下げる
            if re.match("^([0-9a-f]{1})$", filename) != None:
                # この関数を呼び出す（１階層掘り下げて検索）
                if searchAtt1File(path_temp) == False:
                    return False
            # 添付ファイルがあるディレクトリではない
            elif re.match("(.*)_F$", filename) == None:
                FILE_TOTAL += 1
                # メールファイルの更新（作成）日時を取得
                file_ts = os.lstat(path_temp)[ST_MTIME]
                # 1.4.xではタイムスタンプが標準なので＋９時間
                if CONF['ver19'] == False:
                    file_ts += 32400
                # 更新（作成）日時が、規定内であれば必要な情報を保持する
#                if file_ts >= CONF['check_ts']:
                if file_ts >= CONF['check_ts'] or CONF['hour_ago'] == 0:
                    # 添付ファイルディレクトリをチェック
                    if os.path.isfile(path_temp + "_F\\att1") == True:
                        ATT1_FILE_LIST[FILE_COUNT]   = unicode(path_temp + "_F\\att1") # ファイルパス
                        ATT1_FILE_UPDATE[FILE_COUNT] = unicode(time.strftime("%Y-%m-%d %H:%M:%S", time.localtime(file_ts))) # ファイル更新（作成）日時
                        FILE_COUNT = FILE_COUNT + 1 # 該当ファイル数の加算
                        # ソート無しの場合のみ検索数でチェック、ソート有りは全部探す
                        if CONF['file_limit'] > 0 and FILE_COUNT >= CONF['file_limit'] and CONF['setting_sort'] == 0:
                            return False

# -------------------- #
# att1ファイル検索関数 #
# 全ATT1取得用         #
# -------------------- #

def searchAtt1FileAll(search_dir, file_check=False):

    # グローバル変数
    global FILE_COUNT, ATT1_FILE_LIST, ATT1_FILE_UPDATE, FILE_TOTAL, CONF

    # ディレクトリ内を検索開始
    if os.path.isdir(search_dir) == True:
        # ファイル名一覧取得（ディレクトリ名も含む）
        files = os.listdir(search_dir)
        # 取得した一覧から１つずつ抜き出す
        for filename in files:
            # ファイルパス作成
            if CONF['ver19'] == False:
                path_temp = search_dir + "\\" + unicode(filename, "utf-8")
            else:
                path_temp = search_dir + "\\" + filename
            if file_check == True:
                FILE_TOTAL += 1
                # ファイル名が「att1」かチェック
                if filename.lower() == 'att1':
                    # att1ファイルの更新（作成）日時を取得
                    file_ts = os.lstat(path_temp)[ST_MTIME]
                    # 1.4.xではタイムゾーンが標準なので＋９時間
                    if CONF['ver19'] == False:
                        file_ts += 32400
                    # 更新（作成）日時が、規定内であれば必要な情報を保持する
                    if file_ts >= CONF['check_ts'] or CONF['hour_ago'] == 0:
                        ATT1_FILE_LIST[FILE_COUNT]   = unicode(path_temp) # ファイルパス
                        ATT1_FILE_UPDATE[FILE_COUNT] = unicode(time.strftime("%Y-%m-%d %H:%M:%S", time.localtime(file_ts))) # ファイル更新（作成）日時
                        FILE_COUNT = FILE_COUNT + 1 # 該当ファイル数の加算
                        # ソート無しの場合のみ検索数でチェック、ソート有りは全部探す
                        if CONF['file_limit'] > 0 and FILE_COUNT >= CONF['file_limit'] and CONF['setting_sort'] == 0:
                            return False

            # 対象ディレクトリの場合だけ掘り下げる
            elif re.match("^([0-9a-f]{1})$", filename) != None:
                # この関数を呼び出す（１階層掘り下げて検索）
                if searchAtt1FileAll(path_temp, False) == False:
                    return False
            elif re.match("(.*)_F$", filename) != None:
                # この関数を呼び出す（att1検索対象として）
                if searchAtt1FileAll(path_temp, True) == False:
                    return False

        return True


# ------------------------------------ #
# att1ファイル選択時に呼び出される関数 #
# ------------------------------------ #
def select_att1_file():
    global LISTBOX, PATH_LIST, TEMP_FILE_PATH
    key = LISTBOX.current()
    if len(PATH_LIST[key]):
        #PyDMViewerの表示を使用する
        temp_path = TEMP_FILE_PATH + ".html"
        file_path=PATH_LIST[key]
        view_or_sms(action="VIEW", file_path=file_path, temp_file_path=temp_path)
    return True


# ------------ #
# 検索プロセス #
# ------------ #

def procSearch():
    # グローバル変数
    global FILE_COUNT, ATT1_FILE_LIST, ATT1_FILE_UPDATE, FILE_TOTAL, CONF
    global LISTBOX, UPDATE_LIST, PATH_LIST

    # 変数初期化
    ATT1_FILE_LIST   = {}
    ATT1_FILE_UPDATE = {}
    FILE_TOTAL = 0
    FILE_COUNT = 0
    PATH_LIST   = [] # 保持用リスト（ファイルパス）
    UPDATE_LIST = [] # 保持用リスト（ファイル更新日時）

    # 検索時間計測用
    search_ts = time.time()

    #画面をスタート画面に戻し、検索中表示
    set_screen(search=True) 
    set_menu(list=False)

    # att1ファイル検索
    if CONF['setting_ts'] == 1:
        searchAtt1File(CONF['mail_dir'])    #検索対象　ファイルで検索
    else:
        searchAtt1FileAll(CONF['mail_dir']) #検索対象　ディレクトリで検索

    # 検索で取得したatt1ファイル一覧を
    # 更新日時の降順／昇順でソートしてリストに保持
    att_file_count = 0
    wk_dic = {}

    if CONF['setting_sort'] >= 1:
        #ソート有り
        #{日時+key :[日時, ファイルパス]}の辞書を作成
        for key in ATT1_FILE_UPDATE.keys():
            wk_dic[ATT1_FILE_UPDATE[key]+str(key)] = \
              [ATT1_FILE_UPDATE[key], ATT1_FILE_LIST[key]]
        wk_key_list = wk_dic.keys()
        # ソート
        wk_key_list.sort()
        # 降順
        if CONF['setting_sort'] == 1:
            wk_key_list.reverse()
        for key in wk_key_list:
            id_wk = "%02d" %(att_file_count + 1)
            UPDATE_LIST.append(id_wk + " " + wk_dic[key][0])
            PATH_LIST.append(wk_dic[key][1])
            att_file_count += 1
            if CONF['file_limit'] > 0 and att_file_count >= CONF['file_limit']:
                break
    else:
        #ソートなし
        for key in ATT1_FILE_UPDATE.keys():
            id_wk = "%02d" %(att_file_count + 1)
            UPDATE_LIST.append(id_wk + " " + ATT1_FILE_UPDATE[key])
            PATH_LIST.append(ATT1_FILE_LIST[key])
            att_file_count += 1
            if CONF['file_limit'] > 0 and att_file_count >= CONF['file_limit']:
                break

    # 該当件数と検索時間表示（テスト用）
    if att_file_count > 0:
        msg = "%d ファイル中\n %d ファイル発見\n　検索時間 %d秒" % (FILE_TOTAL, att_file_count, (time.time() - search_ts))
        rtn = globalui.global_msg_query(unicode(msg, "utf-8"), unicode("結果", "utf-8"))
#        globalui.global_note(unicode(msg , "utf-8"),  "info") 

        # ファイル情報をリストボックスに渡して表示する
        LISTBOX = appuifw.Listbox(UPDATE_LIST, select_att1_file)
        appuifw.app.body = LISTBOX
        set_menu(list=True)

    else:
        msg = "ファイルが見付かりませんでした。\n検索時間 %d秒" % (time.time() - search_ts)
        rtn = globalui.global_msg_query(unicode(msg, "utf-8"), unicode("結果", "utf-8"))
#        globalui.global_note(unicode(msg, "utf-8"), "info")
        set_screen(search=False) # 検索中画面から通常画面に戻す


# 検索開始
def search():
    global CONF
    # ファイル更新日時比較用タイムスタンプ（グローバル）
    CONF['check_ts'] = time.time() - (60 * 60 * CONF['hour_ago'])
    procSearch()


# オプションMENU

# 設定
def setting():
    global CONF
    form = appuifw.Form([
(unicode("対象ドライブ","utf-8"), "combo",(CONF['drives'], CONF['setting_drive'])),

(unicode("日数制限","utf-8"), "combo",([unicode("制限なし", "utf-8"), unicode("１日以内", "utf-8"), unicode("３日以内", "utf-8"), unicode("７日以内", "utf-8"), unicode("14日以内", "utf-8"), unicode("30日以内", "utf-8")], CONF['setting_days'])),

(unicode("ファイル数制限","utf-8"), "combo",([unicode("制限なし", "utf-8"), unicode("5ﾌｧｲﾙまで", "utf-8"), unicode("10ﾌｧｲﾙまで", "utf-8"), unicode("30ﾌｧｲﾙまで", "utf-8"), unicode("50ﾌｧｲﾙまで", "utf-8"), unicode("100ﾌｧｲﾙまで", "utf-8")], CONF['setting_limit'])),

(unicode("ATT1調整方法","utf-8"), "combo",([unicode("HTML/Browser", "utf-8"), unicode("Plain/Browser", "utf-8"), unicode("HTML/Editor", "utf-8"), unicode("Plain/Editor", "utf-8")], CONF['setting_att1'])),

(unicode("検索対象","utf-8"), "combo",([unicode("ﾃﾞｨﾚｸﾄﾘで(全検索)", "utf-8"), unicode("ﾒｰﾙﾌｧｲﾙで（通常）", "utf-8")], CONF['setting_ts'])),

(unicode("ソート","utf-8"), "combo",([unicode("しない", "utf-8"), unicode("する（降順）", "utf-8"), unicode("する（昇順）", "utf-8")], CONF['setting_sort'])),

(unicode("電話番号（SMS送信先）","utf-8"),"text", unicode(CONF['setting_send_to'],"utf-8")),

(unicode("SMS最大長","utf-8"),"number", CONF['setting_sms_limit'])

], appuifw.FFormDoubleSpaced)
    form.execute()
    # 設定情報更新
    # 検索ドライブ
    CONF['setting_drive'] = int(form[0][2][1])
    if os.path.isdir(CONF['drives'][CONF['setting_drive']] + "\\Private\\1000484b\\Mail2\\00001001_S") == True:
        CONF['mail_dir'] = CONF['drives'][CONF['setting_drive']] + "\\Private\\1000484b\\Mail2\\00001001_S"

    # 日数制限
    CONF['setting_days']  = int(form[1][2][1])
    CONF['hour_ago'] = 24 * DAYS_AGO_MASTER[CONF['setting_days']]

    # ファイル数制限
    CONF['setting_limit'] = int(form[2][2][1])
    CONF['file_limit'] = FILE_LIMIT_MASTER[CONF['setting_limit']]

    # ATT1調整方法
    CONF['setting_att1']  = int(form[3][2][1])

    # 検索対象
    CONF['setting_ts']  = int(form[4][2][1])

    # ｿｰﾄ
    CONF['setting_sort']  = int(form[5][2][1])

    # telephone number
    CONF['setting_send_to']  = form[6][2].encode('utf-8')

    # SMS最大長
    CONF['setting_sms_limit']  = int(form[7][2])

    # 設定保存
    saveConfig()


#--------------------------------------------------------------------------

def show_er_val(Err_no):
    import sys
    type, value = sys.exc_info() [:2]
    #appuifw.note(unicode(str(Err_no)+' '+str(type)+'\n'+str(value)), 'error')
    appuifw.query(unicode(str(Err_no)+' '+str(type)+'\n'+str(value)), 'query')


def check_encode(text_data, encoding=None, error_notice=None):
    global FIXED_ENCODE
    if FIXED_ENCODE:
        enc_list = [FIXED_ENCODE]
    else:
        if encoding: #charset could be detected
            enc_list = [encoding]
        else:
            if JP_CODECS == 1:
                enc_list = ["ISO-2022-JP", "UTF-8", "Shift-JIS"]
#                enc_list = ["ISO-2022-JP", "UTF-8", "Shift-JIS", "EUC-JP", "UTF-16"]
            else:
                enc_list = ["UTF-8"]
#                enc_list = ["UTF-8", "UTF-16"]
    for enc in enc_list:
        try:
            new_data = text_data.decode(enc)
            Enc = enc
            break
        except:
            pass
    else:
        if FIXED_ENCODE:
            Enc =  FIXED_ENCODE
        else:
            if encoding:
                Enc = encoding
            else:
                Enc = "UTF-8"
        try:
            new_data = text_data.decode(Enc, "replace")
        except: # may be never come here
            if error_notice == True:
                #appuifw.note(unicode("Decoding Error\nUnknown Encoding"), "error")
                show_er_val(6)
            Enc = None
            new_data = u''
    return Enc, new_data


def view_or_sms(action, file_path, send_to=None, sms_max_length=192, temp_file_path=None):
    global FIXED_ENCODE
    #表示（action = "VIEW"）、SMS送信（action = "SMS"）
    if not os.path.exists(file_path) :
        appuifw.query(u"Not exist\n att1 File Path", "query")
        return

    if not os.path.isfile(file_path):
        appuifw.query(u"FILE_PATH is not File", "query")
        return

    try:
        F = open(file_path,'rb')
        try:
            wk_text0 = F.read()
        finally:
            F.close()
    except:
        show_er_val(1)
        return # Exit

    if CONF['setting_att1'] == 1 or CONF['setting_att1'] == 3:
        #text/plain 部分取りだし
        Enc = None
        html_format = None
        pos1 = re.search("Transfer-Encoding.binary.", wk_text0, re.I) 
        pos2 = re.search("1.html", wk_text0, re.I) 
        pos3 = re.compile("Content-Transfer-Encoding", re.I).search(wk_text0, 20)
        pos4 = re.search('\x82\x81', wk_text0) 
        if pos1: 
            #
            s_pos = pos1.end()
            if pos2:
                e_pos = pos2.start()
                wk_text0 = wk_text0[s_pos:e_pos - 9] #get text/plain part
            elif pos3:
                e_pos = pos3.start()
                wk_text0 = wk_text0[s_pos:e_pos - 7] #get text/plain part
            elif pos4:
                e_pos = pos4.start()
                wk_text0 = wk_text0[s_pos:e_pos - 4] #get text/plain part
            else:
                wk_text0 = wk_text0[s_pos:] #get #get text/plain -- last part
#            if not FIXED_ENCODE:
#                fixed_encode(1) #set UTF-8
    else:
        # HTML部分取りだし
        Enc = None
        html_format = None
        pos1 = re.search("<HTML>", wk_text0, re.I)  #top of HTML part
        pos2 = re.search("</HTML>", wk_text0, re.I) #end of HTML part
        if pos1: 
            #HTML format
            html_format = True
            s_pos = pos1.start()
            if pos2:
                e_pos = pos2.end()
                wk_text0 = wk_text0[s_pos:e_pos] #get <HTML> ---- </HTML> part
            else:
                wk_text0 = wk_text0[s_pos:] #get <HTML> ---- last part

            #get encoding format
            wk = re.compile('charset=(.+?)[ "]', re.I).findall(wk_text0)
            if wk:
                charset = wk[0]
                enc_list = ("SHIFT-JIS", "SHIFT_JIS", "ISO-2022-JP",\
                            "UTF-8", "UTF_8", "UTF8", "UTF-16", "UTF_16", "UTF16",\
                            "EUC-JP", "EUC_JP", "EUCJP")
                if charset in enc_list:
                    Enc = charset
                else:
                    Enc = None
            else:
                Enc = None

    # check encoding, then decode into unicode 
    Encode, wk_text_uni0 = check_encode(wk_text0, Enc, None)

    if Encode == None: # Can not deocde
        if action == "SMS": # send SMS だがSMS送信はしない
            appuifw.query(unicode("Can not send SMS\n\n(Encoding unknown)", "utf-8"), "query")

        else: #View 表示だけ試みる
            # display mail text
            disp_by_browser(temp_file_path, wk_text0)

        return # EXIT


    #表示する
    if action == "VIEW":
        if CONF['setting_att1'] == 2 or CONF['setting_att1'] == 3:
            #display by editor
            #delete HTML tag (reformat for SMS/display)
            wk_text_uni0 = remove_tag(wk_text_uni0, html_format)
            disp_by_editor(wk_text_uni0)
            return

        #display by browser (CONF['setting_att1'] == 0 or 1)
        if html_format: # Check att1 format
            #HTML format
            if FIXED_ENCODE or not Enc: #fixed encode / no charset data
                #charset= を入れる
                wk_text_uni0 = (re.compile(u"[\n\r]", re.I)).sub(u"" , wk_text_uni0)
                wk_text_uni0 = (re.compile(u"<[/]?html>", re.I)).sub(u"" , wk_text_uni0)
                wk_text_uni0 = (re.compile(u"<head>.*?</head>", re.I)).sub(u"" , wk_text_uni0)
                wk_text_uni0 = (re.compile(u"<[/]?body>", re.I)).sub(u"" , wk_text_uni0)
                wk_text_uni0 = (re.compile(u"<[/]?div>", re.I)).sub(u"" , wk_text_uni0)
                HD1 = u'<HTML><HEAD>'
                HD2 = u'<meta http-equiv="Content-Type" content="text/html; '
                HD3 = u'charset=' + unicode(Encode, "UTF-8") + u'"></HEAD><BODY>'
                HD4 = u'<DIV>'
                TR1 = u'</DIV></BODY></HTML>'
                try:
                    wk_text1 = (HD1+HD2+HD3+HD4+ wk_text_uni0 +TR1).encode(Encode, "replace")
                except:
                    wk_text1 = wk_text0
            else:
                wk_text1 = wk_text0

        else:
            # TEXT(Not HTML format)
            HD1 = u'<HTML><HEAD>'
            HD2 = u'<meta http-equiv="Content-Type" content="text/html; '
            HD3 = u'charset=' + unicode(Encode, "UTF-8") + u'"' + u'></HEAD><BODY>'
            HD4 = u'<DIV>'
            TR1 = u'</DIV></BODY></HTML>'
            # テキストの改行を<br />に変換
            wk_text_uni0 = (re.compile(u"\n", re.I)).sub(u"<br />", wk_text_uni0)
            try:
                wk_text1 = (HD1+HD2+HD3+HD4+ wk_text_uni0 + TR1).encode(Encode, "replace")
            except:
                wk_text1 = wk_text0

        # display mail text
        disp_by_browser(temp_file_path, wk_text1)


    #SMS送信
    else:
        # delete HTML tag (reformat for SMS/display)
        wk_text_uni0 = remove_tag(wk_text_uni0, html_format)

        #  Limit SMS length
        if not sms_max_length: # if sms_max_length == 0,send all data
            sms_text = wk_text_uni0
        else:
            sms_text = wk_text_uni0[:sms_max_length]
        # Send SMS
        if appuifw.query(u"Send Mail_text via SMS ?\n" +u"Text: " + sms_text[:26] + u"..", "query"):
            appuifw.note(u'Sending SMS...', 'info')
            messaging.sms_send(send_to, sms_text, 'UCS2', name='deco mail history')
            appuifw.note(u'Complete: send SMS', 'info')


def remove_tag(text_uni, html_format):
    wk_text_uni0 = text_uni
    if html_format: 
        #HTML format, 改行コード削除
        wk_text_uni0 = (re.compile(u"[\n\r]")).sub(u"", wk_text_uni0)
    # delete HTML tag (reformat for SMS/display)
    # be careful the order of these lines
    #wk_text_uni0 = re.sub(u"[\n\r]", u"", wk_text_uni0)
    wk_text_uni0 = (re.compile(u"<br>", re.I)).sub(u"\n", wk_text_uni0)
    wk_text_uni0 = (re.compile(u"<br />", re.I)).sub(u"\n", wk_text_uni0)
    wk_text_uni0 = re.sub(u"<.+?>", u"", wk_text_uni0)
    wk_text_uni0 = (re.compile(u"&nbsp;", re.I)).sub(u" ", wk_text_uni0)
    wk_text_uni0 = (re.compile(u"&lt;", re.I)).sub(u"<", wk_text_uni0)
    wk_text_uni0 = (re.compile(u"&gt;", re.I)).sub(u">", wk_text_uni0)
    wk_text_uni0 = (re.compile(u"&amp;", re.I)).sub(u"&", wk_text_uni0)
    wk_text_uni0 = (re.compile(u"&quot;", re.I)).sub(u'"', wk_text_uni0)
    wk_text_uni0 = (re.compile(u"&copy;", re.I)).sub(u"(c)", wk_text_uni0)
    return wk_text_uni0


def disp_by_browser(temp_file_path, text):
    try:
      F = open(temp_file_path,'w')
      try:
          F.write(text)
      finally:
          F.close()
    except:
        show_er_val(2)
        return False

    try:
        e32.start_exe('BrowserNG.exe', ' "file:///%s"' % temp_file_path, 1)
    except:
        show_er_val(3)

    #delete temp file
    try:
        os.remove(temp_file_path)
    except:
        show_er_val(4)
    return True


def disp_by_editor(text):
    old_body = appuifw.app.body
    old_handler = appuifw.app.exit_key_handler
    old_menu = appuifw.app.menu
    textbody = appuifw.Text()
    appuifw.app.body = textbody
    appuifw.app.menu = [(unicode("戻る","utf-8"), lambda:lock2.signal()),
                        (unicode("終了","utf-8"), appExit)]
    appuifw.app.exit_key_handler = lambda:lock2.signal()
#    textbody.font = 'normal' #'dense'
    textbody.color = 0x000000
    textbody.set(text)
    textbody.set_pos(0)
    e32.ao_yield() # 画面反映
    lock2.wait()
    appuifw.app.body = old_body
    appuifw.app.exit_key_handler = old_handler
    appuifw.app.menu = old_menu


def send_sms():
    global LISTBOX, UPDATE_LIST, PATH_LIST, CONF
    key = LISTBOX.current()
    if len(PATH_LIST[key]):
        file_path = PATH_LIST[key]
        send_to = CONF['setting_send_to']
        sms_max_length = CONF['setting_sms_limit']
        view_or_sms("SMS", file_path, send_to, sms_max_length)


def fixed_encode(flg=None):
    global FIXED_ENCODE
    sel_list = [u"Automatic", u"UTF-8", u"Shift-JIS", u"ISO-2022-JP"]
#    sel_list = [u"Automatic", u"UTF-8", u"Shift-JIS", u"ISO-2022-JP", u"EUC-JP", u"UTF-16"]
    enc_cd_list =(("", " __"), ("UTF-8", " u8"), ("Shift-JIS", " sj"), ("ISO-2022-JP", " is"), ("EUC-JP", " ej"), ("UTF-16", " u6"))

    if flg == None:
        i = appuifw.popup_menu(sel_list) #show select menu
        if i == None: #select canceled
            return
    else:
        i = flg
    if   i > 3: i = 0 # check value 念のため
#    if   i > 5: i = 0 # check value
    FIXED_ENCODE = enc_cd_list[i][0]
    CODE = enc_cd_list[i][1]
    appuifw.app.title = unicode("PyDecoMailM" + CODE, "utf-8")


def set_screen(search=False):
    global LISTBOX
    if search == True:
        list_wk = [unicode('メール検索中', 'UTF-8'),
                  unicode('お待ちください', 'UTF-8')]
        LISTBOX = appuifw.Listbox(list_wk, do_dummy)
    else:
        list_wk = [unicode('メール検索開始', 'UTF-8'),
                   unicode('設定', 'UTF-8'),
                   unicode('情報', 'UTF-8'),
                   unicode('終了', 'UTF-8') ]
        LISTBOX = appuifw.Listbox(list_wk, menu_select)
    appuifw.app.body = LISTBOX
    e32.ao_yield() # 画面反映


def menu_select():
    global LISTBOX
    cur_pos = LISTBOX.current()
    if   cur_pos == 0: search()
    elif cur_pos == 1: setting()
    elif cur_pos == 2: about()
    else             : appExit()


def set_menu(list=False):
    startscreen = [(unicode("検索開始","utf-8"), search),
                   (unicode("設定","utf-8"), setting),
                   (unicode("情報","utf-8"), about),
                   (unicode("終了","utf-8"), appExit) ]

    listscreen = [(unicode("検索開始","utf-8"), search),
                  (unicode("SMSで送信","utf-8"), send_sms),
                  (unicode("文字コード","utf-8"), fixed_encode),
                  (unicode("ファイル","utf-8"),
                    ((unicode("att1ファイルパス表示","utf-8"), show_file_path),
                     (unicode("att1ファイルコピー","utf-8"), copy_att1_file))),
                  (unicode("設定","utf-8"), setting),
                  (unicode("情報","utf-8"), about),
                  (unicode("終了","utf-8"), appExit) ]
    if list == False:
        appuifw.app.menu = startscreen
    else:
        appuifw.app.menu = listscreen
    appuifw.app.exit_key_handler = lambda:appExit() #lock.signal()#do_dummy()


def show_file_path():
    global LISTBOX, UPDATE_LIST, PATH_LIST
    cur_index = LISTBOX.current()
    file_path = PATH_LIST[cur_index]
    # リスト表示の頭の番号取りだし
    cur_num = UPDATE_LIST[cur_index][:2]
    msg = unicode(str(cur_num),"UTF-8") +u" " + file_path
    appuifw.query(msg, "query")


def copy_att1_file():
    global LISTBOX, UPDATE_LIST, PATH_LIST, TEMP_FILE_PATH
    cur_index = LISTBOX.current()
    file_path = PATH_LIST[cur_index]
    try:
        e32.file_copy(TEMP_FILE_PATH, file_path)
    except:
        show_er_val(8)
    appuifw.query(u"att1 file copyed to\n" + unicode(TEMP_FILE_PATH,"UTF-8"), "query")
#    appuifw.note(u"att1 file copyed to\n" + unicode(TEMP_FILE_PATH,"UTF-8"), "conf")


def about():
    msg = "App: " + __script__ + "\n" + "Version: " + __version__ + "\n" + \
           __copy__ + "\n" + __web__
    appuifw.query(unicode(msg, "UTF-8"), "query")


def do_dummy():
  pass


# アプリ終了
def appExit():
    lock2.signal()
    lock.signal()


def main():
    oldtitle = appuifw.app.title
    appuifw.app.title = unicode("PyDecoMailM __", "utf-8")
    set_screen(search=False)
    # Mailディレクトリが見えるか否かで Open4All 適用済みかチェック
    if not CONF['mail_dir']:
        rtn = globalui.global_msg_query(unicode("AllFiles(Open4All) が適用されていないようです。\n終了します。", "utf-8"), unicode("チェック結果", "utf-8"))
        # 終了
    else:
        set_menu(list=False)
        lock.wait()
    appuifw.app.title = oldtitle


if __name__ == '__main__':
    main()
#    sys.exit()

# --EOF-- #
